<template>
  <div class="app-container">
    <div class="filter-container">

      <el-input v-model="search.keyWord" placeholder="关键字" style="width: 200px;" class="filter-item" />
      <el-button class="filter-item" type="primary" icon="el-icon-search" @click="searchData">
        搜索
      </el-button>

      <el-button
        class="filter-item"
        style="margin-left: 10px;"
        type="primary"
        icon="el-icon-plus"
        @click="handleCreateAdd">
        增加客户等级
      </el-button>
    </div>
    <el-table
      :data="tableData"
      v-loading="listLoading"
      style="width: 100%;margin-bottom: 20px;"
      row-key="id"
      border
      default-expand-all>
      <el-table-column label="操作" align="center" width="230" class-name="small-padding fixed-width">
        <template slot-scope="{row}">
          <el-button @click="handleUpdate(row.id,row.levelName)" type="primary" size="mini">
            编辑
          </el-button>
          <el-button @click="editStatus(row.id,'0')" type="danger" v-if="row.enable==1" size="mini">
            禁用
          </el-button>
          <el-button @click="editStatus(row.id,'1')" v-else="row.enable==0" size="mini">
            启用
          </el-button>


        </template>
      </el-table-column>
      <el-table-column align="center" label="状态" class-name="status-col" width="100">
        <template slot-scope="{row}">
          <el-tag v-if="row.enable==1" type="success">
            启用
          </el-tag>
          <el-tag v-else="row.enable==0" type="danger">
            禁用
          </el-tag>
        </template>
      </el-table-column>
      <el-table-column label="id" align="center" width="50" class-name="small-padding fixed-width">
        <template slot-scope="{row}">
          {{row.id}}
        </template>
      </el-table-column>
      <el-table-column
        prop="levelName"
        label="客户等级名称">
      </el-table-column>



    </el-table>
    <pagination v-show="listData.total>0" :total="listData.total" :page.sync="listData.page" :limit.sync="listData.pageSize" @pagination="getLogisticsInfo" />

    <el-dialog :title="dialogTitle" :visible.sync="dialogVisible" width="500px">
      <el-form label-width="130px" :rules="rules" label-position="right">
        <el-form-item label="客户等级名称">
          <el-input v-model="form.levelName"></el-input>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button @click="dialogVisible = false">取 消</el-button>
        <el-button type="primary" @click="dialogStatus==='1'?addBtn():editBtn()">确 定</el-button>
      </div>
    </el-dialog>
    <!--    <servicedialog @tableRefresh="tableRefresh" ref="menuDialog" :dialogStatus="dialogStatus" :menuId="menuId" :titleDialog="titleDialog" :dialogVisible="dialogVisible"/>-->
    <cancledialog @tableRefresh="tableRefresh" ref="confirmDialog"></cancledialog>
  </div>
</template>

<script>
  import {getInfo,addInfo,updateInfo} from '@/api/doc/level/level.js'
  import Cancledialog from '@/components/Dialog/Cancledialog.vue'
  import Pagination from '@/components/Pagination'

  export default {
    components: {
      Cancledialog,Pagination
    },
    filters: {
      statusFilter(status) {
        const statusMap = {
          1: 'success',
          0: 'danger'
        }
        return statusMap[status]
      }
    },
    data() {
      return {
        dialogStatus: 1,//1增加，2修改
        dialogTitle: '',
        dialogVisible: false,
        search: {
          keyWord:''
        },
        form:{
          levelName:''
        },
        rules: {
          levelName: [
            { required: true, message: '请填写等级名称', trigger: 'blur' }
          ]

        },
        listData:{
          total:0,
          page: 1,
          pageSize:10
        },
        confirmdialog:false,
        listLoading: false,
        tableData: [],
        menuId:''
      }
    },
    mounted() {
      this.getLogisticsInfo();
    },
    methods: {
      //获取列表
      getLogisticsInfo() {
        const _that = this
        _that.listLoading = true
        var params = _that.search;
        var page = {
          pageIndex:_that.listData.page,
          pageSize: _that.listData.pageSize,
        }
        var data = {
          "params": JSON.stringify(params),
          "page": JSON.stringify(page),
        }
        // console.log(data);
        getInfo(data).then(response => {
          // console.log("getIndustryInfo",response)
          const data = response.data
          // //  组合表单数据
          _that.tableData = data
          _that.listData.total = response.total
          // console.log(_that.tableData)
          _that.listLoading = false
        }).catch(err => {
          _that.listLoading = false
        })
      },
      //增加客户等级
      handleCreateAdd(){
        const _that = this
        _that.form={
          levelName:''
        }
        _that.dialogTitle = '增加客户等级'
        _that.dialogStatus = '1';
        _that.dialogVisible = true;

      },
      //刷新表格
      tableRefresh(){
        //刷新变革
        this.getLogisticsInfo()
      },
      //增加
      addBtn(){
        const _that = this
        var info =JSON.stringify(_that.form)
        console.log(info);
        var data = {
          "clientLevel": info ,
        }

        // console.log("clientLevel",data);
        addInfo(data).then(res => {
          // console.log(res);
          if(res.httpCode == 200){
            _that.dialogVisible = false
            _that.$message({
              message: '增加成功',
              type: 'success'
            });
            _that.tableRefresh();
          }else{
            _that.$message.error(res.msg)
          }
        }).catch(err => {
          _that.$message.error(err)
          _that.dialogVisible = true
        })
      },

      //唤起修改
      handleUpdate(id,levelName,industryName){
        const _that = this;

        _that.dialogTitle = '修改客户等级'
        _that.dialogVisible = true
        _that.dialogStatus = '2';

          _that.form={
            id:id,
            levelName:levelName
          }
      },
      //修改档案
      editBtn(){
        const _that = this
        var info =JSON.stringify(_that.form)
        var data = {
          "clientLevel": info ,
        }
        // console.log(data);

        updateInfo(data).then(res => {
          // console.log(res);
          if(res.httpCode == 200){
            _that.dialogVisible = false
            _that.$message({
              message: '修改成功',
              type: 'success'
            });
            _that.tableRefresh();
          }else{
            _that.$message.error(res.msg)
          }
        }).catch(err => {
          _that.$message.error(err)
          _that.dialogVisible = true
        })

      },

      //启用禁用
      editStatus(id,status){
        var _that = this;
        var data = {
          id:id,
          enable:status
        }
        var params = {
          "clientLevel": JSON.stringify(data),
        }

        var url = '/doc/enableClientLevel';
        _that.$refs.confirmDialog.updataClick(params, url);
      },

      //搜索
      searchData(){
        this.listData.page = 1;
        this.getLogisticsInfo()
      }
    }
  }
</script>

<style lang="scss" scoped>
  .filter-container {
    margin-bottom: 15px;
  }
</style>
